diff --git a/main.asm b/main.asm
index 0d81c646..b3e2074b 100755
--- a/main.asm
+++ b/main.asm
@@ -81360,9 +83064,13 @@ Func_517e2: ; 517e2 (14:57e2)
 	call Predef ; indirect jump to Func_ee9e (ee9e (3:6e9e))
 	ret
 
-Unknown_517eb: ; 517eb (14:57eb)
-INCBIN "baserom.gbc",$517eb,$517f1 - $517eb
-	ld hl, Unknown_51816 ; $5816
+VictoryRoad2ScriptPointers: ; 517eb (14:57eb)
+	dw VictoryRoad2Script0
+	dw Func_324c
+	dw EndTrainerBattle
+
+VictoryRoad2Script0: ; 517f1 (14:57f1)
+	ld hl, CoordsData_51816 ; $5816
 	call CheckBoulderCoords
 	jp nc, CheckFightingMapTrainers
 	ld hl, $d7ee
@@ -81382,11 +83090,25 @@ INCBIN "baserom.gbc",$517eb,$517f1 - $517eb
 	set 5, [hl]
 	ret
 
-Unknown_51816: ; 51816 (14:5816)
-INCBIN "baserom.gbc",$51816,$5181b - $51816
+CoordsData_51816: ; 51816 (14:5816)
+	db $10,$01
+	db $10,$09
+	db $FF
 
-VictoryRoad2Texts: ; 5181b (14:581b)
-	dw VictoryRoad2Text1, VictoryRoad2Text2, VictoryRoad2Text3, VictoryRoad2Text4, VictoryRoad2Text5, VictoryRoad2Text6, Predef5CText, Predef5CText, Predef5CText, Predef5CText, BoulderText, BoulderText, BoulderText
+VictoryRoad2TextPointers: ; 5181b (14:581b)
+	dw VictoryRoad2Text1
+	dw VictoryRoad2Text2
+	dw VictoryRoad2Text3
+	dw VictoryRoad2Text4
+	dw VictoryRoad2Text5
+	dw VictoryRoad2Text6
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw BoulderText
+	dw BoulderText
+	dw BoulderText
 
 VictoryRoad2TrainerHeaders: ; 51835 (14:5835)
 VictoryRoad2TrainerHeader0: ; 51835 (14:5835)
@@ -81443,7 +83165,7 @@ VictoryRoad2TrainerHeader6: ; 51871 (14:5871)
 	dw VictoryRoad2BattleText6 ; 0x58ba TextEndBattle
 	dw VictoryRoad2BattleText6 ; 0x58ba TextEndBattle
 
-db $ff
+	db $ff
 
 VictoryRoad2Text1: ; 5187e (14:587e)
 	db $08 ; asm
@@ -81593,7 +83315,7 @@ VictoryRoad2Blocks: ; 519af (14:59af)
 MtMoon2_h: ; 0x51a36 to 0x51a42 (12 bytes) (id=60)
 	db $11 ; tileset
 	db MT_MOON_2_HEIGHT, MT_MOON_2_WIDTH ; dimensions (y, x)
-	dw MtMoon2Blocks, MtMoon2Texts, MtMoon2Script ; blocks, texts, scripts
+	dw MtMoon2Blocks, MtMoon2TextPointers, MtMoon2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw MtMoon2Object ; objects
@@ -81602,7 +83324,7 @@ MtMoon2Script: ; 51a42 (14:5a42)
 	call EnableAutoTextBoxDrawing
 	ret
 
-MtMoon2Texts: ; 51a46 (14:5a46)
+MtMoon2TextPointers: ; 51a46 (14:5a46)
 	dw MtMoonText1
 
 MtMoonText1: ; 51a48 (14:5a48)
@@ -81642,22 +83364,22 @@ MtMoon2Blocks: ; 51a91 (14:5a91)
 SilphCo7_h: ; 0x51b55 to 0x51b61 (12 bytes) (id=212)
 	db $16 ; tileset
 	db SILPH_CO_7F_HEIGHT, SILPH_CO_7F_WIDTH ; dimensions (y, x)
-	dw SilphCo7Blocks, SilphCo7Texts, SilphCo7Script ; blocks, texts, scripts
+	dw SilphCo7Blocks, SilphCo7TextPointers, SilphCo7Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SilphCo7Object ; objects
 
 SilphCo7Script: ; 51b61 (14:5b61)
-	call SilphCo7Script_Unknown51b77
+	call SilphCo7Script_51b77
 	call EnableAutoTextBoxDrawing
 	ld hl, SilphCo7TrainerHeaders
-	ld de, Unknown_51c17 ; $5c17
+	ld de, SilphCo7ScriptPointers
 	ld a, [W_SILPHCO7CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_SILPHCO7CURSCRIPT], a
 	ret
 
-SilphCo7Script_Unknown51b77: ; 51b77 (14:5b77)
+SilphCo7Script_51b77: ; 51b77 (14:5b77)
 	ld hl, $d126
 	bit 5, [hl]
 	res 5, [hl]
@@ -81760,12 +83482,19 @@ Func_51c10: ; 51c10 (14:5c10)
 	ld [W_CURMAPSCRIPT], a
 	ret
 
-Unknown_51c17: ; 51c17 (14:5c17)
-INCBIN "baserom.gbc",$51c17,$51c23 - $51c17
+SilphCo7ScriptPointers: ; 51c17 (14:5c17)
+	dw SilphCo7Script0
+	dw Func_324c
+	dw EndTrainerBattle
+	dw SilphCo7Script3
+	dw SilphCo7Script4
+	dw SilphCo7Script5
+
+SilphCo7Script0: ; 51c23 (14:5c23)
 	ld a, [$d82f]
 	bit 0, a
 	jp nz, CheckFightingMapTrainers
-	ld hl, Unknown_51c78 ; $5c78
+	ld hl, CoordsData_51c78
 	call ArePlayerCoordsInArray
 	jp nc, CheckFightingMapTrainers
 	xor a
@@ -81786,7 +83515,7 @@ INCBIN "baserom.gbc",$51c17,$51c23 - $51c17
 	ld a, $9
 	ld [H_DOWNARROWBLINKCNT2], a ; $FF00+$8c
 	call SetSpriteMovementBytesToFF
-	ld de, Unknown_51c7d ; $5c7d
+	ld de, MovementData_51c7d
 	ld a, [wWhichTrade] ; $cd3d
 	ld [$cf0d], a
 	cp $1
@@ -81799,11 +83528,15 @@ INCBIN "baserom.gbc",$51c17,$51c23 - $51c17
 	ld a, $3
 	jp Func_51c10
 
-Unknown_51c78: ; 51c78 (14:5c78)
-INCBIN "baserom.gbc",$51c78,$51c7d - $51c78
+CoordsData_51c78: ; 51c78 (14:5c78)
+	db $02,$03
+	db $03,$03
+	db $FF
 
-Unknown_51c7d: ; 51c7d (14:5c7d)
-INCBIN "baserom.gbc",$51c7d,$51c82 - $51c7d
+MovementData_51c7d: ; 51c7d (14:5c7d)
+	db $40,$40,$40,$40,$FF
+
+SilphCo7Script3: ; 51c82 (14:5c82)
 	ld a, [$d730]
 	bit 0, a
 	ret nz
@@ -81837,6 +83570,8 @@ INCBIN "baserom.gbc",$51c7d,$51c82 - $51c7d
 	ld [W_TRAINERNO], a ; $d05d
 	ld a, $4
 	jp Func_51c10
+
+SilphCo7Script4: ; 51cc8 (14:5cc8)
 	ld a, [W_ISINBATTLE] ; $d057
 	cp $ff
 	jp z, Func_51c0c
@@ -81860,11 +83595,11 @@ INCBIN "baserom.gbc",$51c7d,$51c82 - $51c7d
 	ld b, BANK(Music_RivalAlternateStart)
 	ld hl, Music_RivalAlternateStart
 	call Bankswitch ; indirect jump to Music_RivalAlternateStart (9b47 (2:5b47))
-	ld de, Unknown_51d1d ; $5d1d
+	ld de, MovementData_51d1d
 	ld a, [$cf0d]
 	cp $1
 	jr nz, .asm_51d0e
-	ld de, Unknown_51d1a ; $5d1a
+	ld de, MovementData_51d1a
 .asm_51d0e
 	ld a, $9
 	ld [H_DOWNARROWBLINKCNT2], a ; $FF00+$8c
@@ -81872,11 +83607,13 @@ INCBIN "baserom.gbc",$51c7d,$51c82 - $51c7d
 	ld a, $5
 	jp Func_51c10
 
-Unknown_51d1a: ; 51d1a (14:5d1a)
-INCBIN "baserom.gbc",$51d1a,$51d1d - $51d1a
+MovementData_51d1a: ; 51d1a (14:5d1a)
+	db $C0,$C0,$FF
 
-Unknown_51d1d: ; 51d1d (14:5d1d)
-INCBIN "baserom.gbc",$51d1d,$51d25 - $51d1d
+MovementData_51d1d: ; 51d1d (14:5d1d)
+	db $80,$40,$40,$C0,$C0,$C0,$00,$FF
+
+SilphCo7Script5: ; 51d25 (14:5d25)
 	ld a, [$d730]
 	bit 0, a
 	ret nz
@@ -81889,8 +83626,22 @@ INCBIN "baserom.gbc",$51d1d,$51d25 - $51d1d
 	ld [wJoypadForbiddenButtonsMask], a
 	jp Func_51c10
 
-SilphCo7Texts: ; 51d3f (14:5d3f)
-	dw SilphCo7Text1, SilphCo7Text2, SilphCo7Text3, SilphCo7Text4, SilphCo7Text5, SilphCo7Text6, SilphCo7Text7, SilphCo7Text8, SilphCo7Text9, Predef5CText, Predef5CText, Predef5CText, SilphCo7Text13, SilphCo7Text14, SilphCo7Text15
+SilphCo7TextPointers: ; 51d3f (14:5d3f)
+	dw SilphCo7Text1
+	dw SilphCo7Text2
+	dw SilphCo7Text3
+	dw SilphCo7Text4
+	dw SilphCo7Text5
+	dw SilphCo7Text6
+	dw SilphCo7Text7
+	dw SilphCo7Text8
+	dw SilphCo7Text9
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw SilphCo7Text13
+	dw SilphCo7Text14
+	dw SilphCo7Text15
 
 SilphCo7TrainerHeaders: ; 51d5d (14:5d5d)
 SilphCo7TrainerHeader0: ; 51d5d (14:5d5d)
@@ -81929,7 +83680,7 @@ SilphCo7TrainerHeader4: ; 51d81 (14:5d81)
 	dw SilphCo7EndBattleText4 ; 0x5eaa TextEndBattle
 	dw SilphCo7EndBattleText4 ; 0x5eaa TextEndBattle
 
-db $ff
+	db $ff
 
 SilphCo7Text1: ; 51d8e (14:5d8e)
 	db $08 ; asm
@@ -82183,7 +83934,7 @@ SilphCo7Blocks: ; 51f57 (14:5f57)
 Mansion2_h: ; 0x51fcc to 0x51fd8 (12 bytes) (id=214)
 	db $16 ; tileset
 	db MANSION_2_HEIGHT, MANSION_2_WIDTH ; dimensions (y, x)
-	dw Mansion2Blocks, Mansion2Texts, Mansion2Script ; blocks, texts, scripts
+	dw Mansion2Blocks, Mansion2TextPointers, Mansion2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Mansion2Object ; objects
@@ -82192,7 +83943,7 @@ Mansion2Script: ; 51fd8 (14:5fd8)
 	call Mansion2Script_Unknown51fee
 	call EnableAutoTextBoxDrawing
 	ld hl, Mansion2TrainerHeaders
-	ld de, Unknown_52047 ; $6047
+	ld de, Mansion2ScriptPointers
 	ld a, [W_MANSION2CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_MANSION2CURSCRIPT], a
@@ -82233,13 +83984,27 @@ Func_5202f: ; 5202f (14:602f)
 	ld a, $17
 	jp Predef ; indirect jump to Func_ee9e (ee9e (3:6e9e))
 
-INCBIN "baserom.gbc",$52037,$52047 - $52037
+Func_52037: ; 52037 (14:6037)
+	ld a, [$c109]
+	cp $4
+	ret nz
+	xor a
+	ld [H_CURRENTPRESSEDBUTTONS], a
+	ld a, $5
+	ld [H_SPRITEHEIGHT], a
+	jp DisplayTextID
 
-Unknown_52047: ; 52047 (14:6047)
-INCBIN "baserom.gbc",$52047,$5204d - $52047
+Mansion2ScriptPointers: ; 52047 (14:6047)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Mansion2Texts: ; 5204d (14:604d)
-	dw Mansion2Text1, Predef5CText, Mansion2Text3, Mansion2Text4, Mansion2Text5
+Mansion2TextPointers: ; 5204d (14:604d)
+	dw Mansion2Text1
+	dw Predef5CText
+	dw Mansion2Text3
+	dw Mansion2Text4
+	dw Mansion2Text5
 
 Mansion2TrainerHeaders: ; 52057 (14:6057)
 Mansion2TrainerHeader0: ; 52057 (14:6057)
@@ -82251,7 +84016,7 @@ Mansion2TrainerHeader0: ; 52057 (14:6057)
 	dw Mansion2EndBattleText1 ; 0x6073 TextEndBattle
 	dw Mansion2EndBattleText1 ; 0x6073 TextEndBattle
 
-db $ff
+	db $ff
 
 Mansion2Text1: ; 52064 (14:6064)
 	db $08 ; asm
@@ -82349,22 +84114,22 @@ Mansion2Blocks: ; 52110 (14:6110)
 Mansion3_h: ; 0x521e2 to 0x521ee (12 bytes) (id=215)
 	db $16 ; tileset
 	db MANSION_3_HEIGHT, MANSION_3_WIDTH ; dimensions (y, x)
-	dw Mansion3Blocks, Mansion3Texts, Mansion3Script ; blocks, texts, scripts
+	dw Mansion3Blocks, Mansion3TextPointers, Mansion3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Mansion3Object ; objects
 
 Mansion3Script: ; 521ee (14:61ee)
-	call Unnamed_52204
+	call Mansion3Script_52204
 	call EnableAutoTextBoxDrawing
 	ld hl, Mansion3TrainerHeader0
-	ld de, Unknown_52235 ; $6235
+	ld de, Mansion3ScriptPointers
 	ld a, [W_MANSION3CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_MANSION3CURSCRIPT], a
 	ret
 
-Unnamed_52204: ; 52204 (14:6204)
+Mansion3Script_52204: ; 52204 (14:6204)
 	ld hl, $d126
 	bit 5, [hl]
 	res 5, [hl]
@@ -82388,9 +84153,13 @@ Unnamed_52204: ; 52204 (14:6204)
 	call Func_5202f
 	ret
 
-Unknown_52235: ; 52235 (14:6235)
-INCBIN "baserom.gbc",$52235,$5223b - $52235
-	ld hl, Unknown_52254 ; $6254
+Mansion3ScriptPointers: ; 52235 (14:6235)
+	dw Mansion3Script0
+	dw Func_324c
+	dw EndTrainerBattle
+
+Mansion3Script0: ; 5223b (14:623b)
+	ld hl, CoordsData_52254
 	call Func_5225b
 	ld a, [$d71e]
 	and a
@@ -82403,8 +84172,11 @@ INCBIN "baserom.gbc",$52235,$5223b - $52235
 	ld [$d71d], a
 	ret
 
-Unknown_52254: ; 52254 (14:6254)
-INCBIN "baserom.gbc",$52254,$5225b - $52254
+CoordsData_52254: ; 52254 (14:6254)
+	db $0E,$10
+	db $0E,$11
+	db $0E,$13
+	db $FF
 
 Func_5225b: ; 5225b (14:625b)
 	xor a
@@ -82430,8 +84202,13 @@ Func_5225b: ; 5225b (14:625b)
 	ld [H_DOWNARROWBLINKCNT2], a ; $FF00+$8c
 	jp DisplayTextID
 
-Mansion3Texts: ; 5228a (14:628a)
-	dw Mansion3Text1, Mansion3Text2, Predef5CText, Predef5CText, Mansion3Text5, Mansion3Text6
+Mansion3TextPointers: ; 5228a (14:628a)
+	dw Mansion3Text1
+	dw Mansion3Text2
+	dw Predef5CText
+	dw Predef5CText
+	dw Mansion3Text5
+	dw Mansion3Text6
 
 Mansion3TrainerHeaders: ; 52296 (14:6296)
 Mansion3TrainerHeader0: ; 52296 (14:6296)
@@ -82452,7 +84229,7 @@ Mansion3TrainerHeader2: ; 522a2 (14:62a2)
 	dw Mansion3EndBattleText2 ; 0x62d7 TextEndBattle
 	dw Mansion3EndBattleText2 ; 0x62d7 TextEndBattle
 
-db $ff
+	db $ff
 
 Mansion3Text1: ; 522af (14:62af)
 	db $08 ; asm
@@ -82522,7 +84299,7 @@ Mansion3Blocks: ; 52326 (14:6326)
 Mansion4_h: ; 0x523ad to 0x523b9 (12 bytes) (id=216)
 	db $16 ; tileset
 	db MANSION_4_HEIGHT, MANSION_4_WIDTH ; dimensions (y, x)
-	dw Mansion4Blocks, Mansion4Texts, Mansion4Script ; blocks, texts, scripts
+	dw Mansion4Blocks, Mansion4TextPointers, Mansion4Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Mansion4Object ; objects
@@ -82531,7 +84308,7 @@ Mansion4Script: ; 523b9 (14:63b9)
 	call Unknown_523cf
 	call EnableAutoTextBoxDrawing
 	ld hl, Mansion4TrainerHeader0
-	ld de, Unknown_52430 ; $6430
+	ld de, Mansion4ScriptPointers
 	ld a, [W_MANSION4CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_MANSION4CURSCRIPT], a
@@ -82581,11 +84358,21 @@ Unknown_523cf: ; 523cf (14:63cf)
 	ld [H_DOWNARROWBLINKCNT2], a ; $FF00+$8c
 	jp DisplayTextID
 
-Unknown_52430: ; 52430 (14:6430)
-INCBIN "baserom.gbc",$52430,$52436 - $52430
+Mansion4ScriptPointers: ; 52430 (14:6430)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Mansion4Texts: ; 52436 (14:6436)
-INCBIN "baserom.gbc",$52436,$52448 - $52436
+Mansion4TextPointers: ; 52436 (14:6436)
+	dw Mansion4Text1
+	dw Mansion4Text2
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Predef5CText
+	dw Mansion4Text7
+	dw Predef5CText
+	dw Mansion3Text6
 
 Mansion4TrainerHeaders: ; 52448 (14:6448)
 Mansion4TrainerHeader0: ; 52448 (14:6448)
@@ -82606,7 +84393,7 @@ Mansion4TrainerHeader2: ; 52454 (14:6454)
 	dw Mansion4EndBattleText2 ; 0x6489 TextEndBattle
 	dw Mansion4EndBattleText2 ; 0x6489 TextEndBattle
 
-db $ff
+	db $ff
 
 Mansion4Text1: ; 52461 (14:6461)
 	db $08 ; asm
@@ -83327,7 +85114,7 @@ Route2_h: ; 54000 (15:4000)
 	db 00 ; Tileset
 	db ROUTE_2_HEIGHT,ROUTE_2_WIDTH ;Height,Width blocks (1 block = 4x4 tiles)
 	dw Route2Blocks ;Map-Pointer
-	dw Route2Texts ;Maps text pointer
+	dw Route2TextPointers ;Maps text pointer
 	dw Route2Script ;Maps script pointer
 	db NORTH | SOUTH ;Connection Byte
 
@@ -83387,7 +85174,7 @@ Route2Blocks: ; 5407e (15:407e)
 Route3_h: ; 0x541e6 to 0x54208 (34 bytes) (id=14)
 	db $00 ; tileset
 	db ROUTE_3_HEIGHT, ROUTE_3_WIDTH ; dimensions (y, x)
-	dw Route3Blocks, Route3Texts, Route3Script ; blocks, texts, scripts
+	dw Route3Blocks, Route3TextPointers, Route3Script ; blocks, texts, scripts
 	db NORTH | WEST ; connections
 
 	; connections data
@@ -83435,7 +85222,7 @@ Route3Blocks: ; 54255 (15:4255)
 Route4_h: ; 0x54390 to 0x543b2 (34 bytes) (id=15)
 	db $00 ; tileset
 	db ROUTE_4_HEIGHT, ROUTE_4_WIDTH ; dimensions (y, x)
-	dw Route4Blocks, Route4Texts, Route4Script; blocks, texts, scripts
+	dw Route4Blocks, Route4TextPointers, Route4Script; blocks, texts, scripts
 	db SOUTH | EAST ; connections
 
 	; connections data
@@ -83487,7 +85274,7 @@ Route4Blocks: ; 543ec (15:43ec)
 Route5_h: ; 0x54581 to 0x545a3 (34 bytes) (id=16)
 	db $00 ; tileset
 	db ROUTE_5_HEIGHT, ROUTE_5_WIDTH ; dimensions (y, x)
-	dw Route5Blocks, Route5Texts, Route5Script ; blocks, texts, scripts
+	dw Route5Blocks, Route5TextPointers, Route5Script ; blocks, texts, scripts
 	db NORTH | SOUTH ; connections
 
 	; connections data
@@ -83538,7 +85325,7 @@ Route5Blocks: ; 545d2 (15:45d2)
 Route9_h: ; 0x54686 to 0x546a8 (34 bytes) (id=20)
 	db $00 ; tileset
 	db ROUTE_9_HEIGHT, ROUTE_9_WIDTH ; dimensions (y, x)
-	dw Route9Blocks, Route9Texts, Route9Script ; blocks, texts, scripts
+	dw Route9Blocks, Route9TextPointers, Route9Script ; blocks, texts, scripts
 	db WEST | EAST ; connections
 
 	; connections data
@@ -83587,7 +85374,7 @@ Route9Blocks: ; 546fe (15:46fe)
 Route13_h: ; 0x5480c to 0x5482e (34 bytes) (id=24)
 	db $00 ; tileset
 	db ROUTE_13_HEIGHT, ROUTE_13_WIDTH ; dimensions (y, x)
-	dw Route13Blocks, Route13Texts, Route13Script ; blocks, texts, scripts
+	dw Route13Blocks, Route13TextPointers, Route13Script ; blocks, texts, scripts
 	db NORTH | WEST ; connections
 
 	; connections data
@@ -83638,7 +85425,7 @@ Route13Blocks: ; 5488b (15:488b)
 Route14_h: ; 0x54999 to 0x549bb (34 bytes) (id=25)
 	db $00 ; tileset
 	db ROUTE_14_HEIGHT, ROUTE_14_WIDTH ; dimensions (y, x)
-	dw Route14Blocks, Route14Texts, Route14Script ; blocks, texts, scripts
+	dw Route14Blocks, Route14TextPointers, Route14Script ; blocks, texts, scripts
 	db WEST | EAST ; connections
 
 	; connections data
@@ -83687,7 +85474,7 @@ Route14Blocks: ; 54a12 (15:4a12)
 Route17_h: ; 0x54b20 to 0x54b42 (34 bytes) (id=28)
 	db $00 ; tileset
 	db ROUTE_17_HEIGHT, ROUTE_17_WIDTH ; dimensions (y, x)
-	dw Route17Blocks, Route17Texts, Route17Script ; blocks, texts, scripts
+	dw Route17Blocks, Route17TextPointers, Route17Script ; blocks, texts, scripts
 	db NORTH | SOUTH ; connections
 
 	; connections data
@@ -83741,7 +85528,7 @@ Route17Blocks: ; 54ba8 (15:4ba8)
 Route19_h: ; 0x54e78 to 0x54e9a (34 bytes) (id=30)
 	db $00 ; tileset
 	db ROUTE_19_HEIGHT, ROUTE_19_WIDTH ; dimensions (y, x)
-	dw Route19Blocks, Route19Texts, Route19Script ; blocks, texts, scripts
+	dw Route19Blocks, Route19TextPointers, Route19Script ; blocks, texts, scripts
 	db NORTH | WEST ; connections
 
 	; connections data
@@ -83790,7 +85577,7 @@ Route19Blocks: ; 54ef1 (15:4ef1)
 Route21_h: ; 0x54fff to 0x55021 (34 bytes) (id=32)
 	db $00 ; tileset
 	db ROUTE_21_HEIGHT, ROUTE_21_WIDTH ; dimensions (y, x)
-	dw Route21Blocks, Route21Texts, Route21Script ; blocks, texts, scripts
+	dw Route21Blocks, Route21TextPointers, Route21Script ; blocks, texts, scripts
 	db NORTH | SOUTH ; connections
 
 	; connections data
@@ -84222,8 +86009,11 @@ INCBIN "baserom.gbc",$554dd,$554e3 - $554dd
 Route2Script: ; 554e3 (15:54e3)
 	jp EnableAutoTextBoxDrawing
 
-Route2Texts: ; 554e6 (15:54e6)
-	dw Predef5CText, Predef5CText, Route2Text3, Route2Text4
+Route2TextPointers: ; 554e6 (15:54e6)
+	dw Predef5CText
+	dw Predef5CText
+	dw Route2Text3
+	dw Route2Text4
 
 Route2Text3: ; 554ee (15:54ee)
 	TX_FAR _Route2Text3
@@ -84236,17 +86026,28 @@ Route2Text4: ; 554f3 (15:54f3)
 Route3Script: ; 554f8 (15:54f8)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route3TrainerHeader0
-	ld de, Unknown_5550b
+	ld de, Route3ScriptPointers
 	ld a, [W_ROUTE3CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE3CURSCRIPT], a
 	ret
 
-Unknown_5550b: ; 5550b (15:550b)
-INCBIN "baserom.gbc",$5550b,$55511 - $5550b
+Route3ScriptPointers: ; 5550b (15:550b)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route3Texts: ; 55511 (15:5511)
-	dw Route3Text1, Route3Text2, Route3Text3, Route3Text4, Route3Text5, Route3Text6, Route3Text7, Route3Text8, Route3Text9, Route3Text10
+Route3TextPointers: ; 55511 (15:5511)
+	dw Route3Text1
+	dw Route3Text2
+	dw Route3Text3
+	dw Route3Text4
+	dw Route3Text5
+	dw Route3Text6
+	dw Route3Text7
+	dw Route3Text8
+	dw Route3Text9
+	dw Route3Text10
 
 Route3TrainerHeaders: ; 55525 (15:5525)
 Route3TrainerHeader0: ; 55525 (15:5525)
@@ -84321,7 +86122,7 @@ Route3TrainerHeader8: ; 55579 (15:5579)
 	dw Route3EndBattleText8 ; 0x5649 TextEndBattle
 	dw Route3EndBattleText8 ; 0x5649 TextEndBattle
 
-db $ff
+	db $ff
 
 Route3Text1: ; 55586 (15:5586)
 	TX_FAR _Route3Text1
@@ -84478,17 +86279,24 @@ Route3Text10: ; 55653 (15:5653)
 Route4Script: ; 55658 (15:5658)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route4TrainerHeaders
-	ld de, Unknown_5566b
+	ld de, Route4ScriptPointers
 	ld a, [W_ROUTE4CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE4CURSCRIPT], a
 	ret
 
-Unknown_5566b: ; 5566b (15:566b)
-INCBIN "baserom.gbc",$5566b,$55671 - $5566b
+Route4ScriptPointers: ; 5566b (15:566b)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route4Texts: ; 55671 (15:5671)
-	dw Route4Text1, Route4Text2, Predef5CText, PokeCenterSignText, Route4Text5, Route4Text6
+Route4TextPointers: ; 55671 (15:5671)
+	dw Route4Text1
+	dw Route4Text2
+	dw Predef5CText
+	dw PokeCenterSignText
+	dw Route4Text5
+	dw Route4Text6
 
 Route4TrainerHeaders: ; 5567d (15:567d)
 Route4TrainerHeader0: ; 5567d (15:567d)
@@ -84500,7 +86308,7 @@ Route4TrainerHeader0: ; 5567d (15:567d)
 	dw Route4EndBattleText1 ; 0x569e TextEndBattle
 	dw Route4EndBattleText1 ; 0x569e TextEndBattle
 
-db $ff
+	db $ff
 
 Route4Text1: ; 5568a (15:568a)
 	TX_FAR _Route4Text1
@@ -84535,7 +86343,7 @@ Route4Text6: ; 556ad (15:56ad)
 Route5Script: ; 556b2 (15:56b2)
 	jp EnableAutoTextBoxDrawing
 
-Route5Texts: ; 556b5 (15:56b5)
+Route5TextPointers: ; 556b5 (15:56b5)
 	dw Route5Text1
 
 Route5Text1: ; 556b7 (15:56b7)
@@ -84545,17 +86353,29 @@ Route5Text1: ; 556b7 (15:56b7)
 Route9Script: ; 556bc (15:56bc)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route9TrainerHeaders
-	ld de, Unknown_556cf
+	ld de, Route9ScriptPointers
 	ld a, [W_ROUTE9CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE9CURSCRIPT], a
 	ret
 
-Unknown_556cf: ; 556cf (15:56cf)
-INCBIN "baserom.gbc",$556cf,$556d5 - $556cf
+Route9ScriptPointers: ; 556cf (15:56cf)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route9Texts: ; 556d5 (15:56d5)
-	dw Route9Text1, Route9Text2, Route9Text3, Route9Text4, Route9Text5, Route9Text6, Route9Text7, Route9Text8, Route9Text9, Predef5CText, Route9Text11
+Route9TextPointers: ; 556d5 (15:56d5)
+	dw Route9Text1
+	dw Route9Text2
+	dw Route9Text3
+	dw Route9Text4
+	dw Route9Text5
+	dw Route9Text6
+	dw Route9Text7
+	dw Route9Text8
+	dw Route9Text9
+	dw Predef5CText
+	dw Route9Text11
 
 Route9TrainerHeaders: ; 556eb (15:56eb)
 Route9TrainerHeader0: ; 556eb (15:56eb)
@@ -84639,7 +86459,7 @@ Route9TrainerHeader9: ; 5574b (15:574b)
 	dw Route9EndBattleText9 ; 0x580f TextEndBattle
 	dw Route9EndBattleText9 ; 0x580f TextEndBattle
 
-db $ff
+	db $ff
 
 Route9Text1: ; 55758 (15:5758)
 	db $8 ; asm
@@ -84803,17 +86623,31 @@ Route9Text11: ; 55819 (15:5819)
 Route13Script: ; 5581e (15:581e)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route13TrainerHeaders
-	ld de, Route13Script_Unknown55831
+	ld de, Route13ScriptPointers
 	ld a, [W_ROUTE13CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE13CURSCRIPT], a
 	ret
 
-Route13Script_Unknown55831: ; 55831 (15:5831)
-INCBIN "baserom.gbc",$55831,$55837 - $55831
+Route13ScriptPointers: ; 55831 (15:5831)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route13Texts: ; 55837 (15:5837)
-	dw Route13Text1, Route13Text2, Route13Text3, Route13Text4, Route13Text5, Route13Text6, Route13Text7, Route13Text8, Route13Text9, Route13Text10, Route13Text11, Route13Text12, Route13Text13
+Route13TextPointers: ; 55837 (15:5837)
+	dw Route13Text1
+	dw Route13Text2
+	dw Route13Text3
+	dw Route13Text4
+	dw Route13Text5
+	dw Route13Text6
+	dw Route13Text7
+	dw Route13Text8
+	dw Route13Text9
+	dw Route13Text10
+	dw Route13Text11
+	dw Route13Text12
+	dw Route13Text13
 
 Route13TrainerHeaders: ; 55851 (15:5851)
 Route13TrainerHeader0: ; 55851 (15:5851)
@@ -84906,7 +86740,7 @@ Route13TrainerHeader10: ; 558bd (15:58bd)
 	dw Route13EndBattleText11 ; 0x59ba TextEndBattle
 	dw Route13EndBattleText11 ; 0x59ba TextEndBattle
 
-db $ff
+	db $ff
 
 Route13Text1: ; 558ca (15:58ca)
 	db $08 ; asm
@@ -85103,17 +86937,29 @@ Route13Text13: ; 559ce (15:59ce)
 Route14Script: ; 559d3 (15:59d3)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route14TrainerHeaders
-	ld de, Unknown_559e6
+	ld de, Route14ScriptPointers
 	ld a, [W_ROUTE14CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE14CURSCRIPT], a
 	ret
 
-Unknown_559e6: ; 559e6 (15:59e6)
-INCBIN "baserom.gbc",$559e6,$559ec - $559e6
+Route14ScriptPointers: ; 559e6 (15:59e6)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route14Texts: ; 559ec (15:59ec)
-	dw Route14Text1, Route14Text2, Route14Text3, Route14Text4, Route14Text5, Route14Text6, Route14Text7, Route14Text8, Route14Text9, Route14Text10, Route14Text11
+Route14TextPointers: ; 559ec (15:59ec)
+	dw Route14Text1
+	dw Route14Text2
+	dw Route14Text3
+	dw Route14Text4
+	dw Route14Text5
+	dw Route14Text6
+	dw Route14Text7
+	dw Route14Text8
+	dw Route14Text9
+	dw Route14Text10
+	dw Route14Text11
 
 Route14TrainerHeaders: ; 55a02 (15:5a02)
 Route14TrainerHeader0: ; 55a02 (15:5a02)
@@ -85206,7 +87052,7 @@ Route14TrainerHeader9: ; 55a6e (15:5a6e)
 	dw Route14EndBattleText10 ; 0x5b6b TextEndBattle
 	dw Route14EndBattleText10 ; 0x5b6b TextEndBattle
 
-db $ff
+	db $ff
 
 Route14Text1: ; 55a7b (15:5a7b)
 	db $08 ; asm
@@ -85395,17 +87241,34 @@ Route14Text11: ; 55b75 (15:5b75)
 Route17Script: ; 55b7a (15:5b7a)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route17TrainerHeaders
-	ld de, Route17_Unknown55b8d
+	ld de, Route17ScriptPointers
 	ld a, [W_ROUTE17CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE17CURSCRIPT], a
 	ret
 
-Route17_Unknown55b8d: ; 55b8d (15:5b8d)
-INCBIN "baserom.gbc",$55b8d,$55b93 - $55b8d
+Route17ScriptPointers: ; 55b8d (15:5b8d)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route17Texts: ; 55b93 (15:5b93)
-	dw Route17Text1, Route17Text2, Route17Text3, Route17Text4, Route17Text5, Route17Text6, Route17Text7, Route17Text8, Route17Text9, Route17Text10, Route17Text11, Route17Text12, Route17Text13, Route17Text14, Route17Text15, Route17Text16
+Route17TextPointers: ; 55b93 (15:5b93)
+	dw Route17Text1
+	dw Route17Text2
+	dw Route17Text3
+	dw Route17Text4
+	dw Route17Text5
+	dw Route17Text6
+	dw Route17Text7
+	dw Route17Text8
+	dw Route17Text9
+	dw Route17Text10
+	dw Route17Text11
+	dw Route17Text12
+	dw Route17Text13
+	dw Route17Text14
+	dw Route17Text15
+	dw Route17Text16
 
 Route17TrainerHeaders: ; 55bb3 (15:5bb3)
 Route17TrainerHeader0: ; 55bb3 (15:5bb3)
@@ -85498,7 +87361,7 @@ Route17TrainerHeader9: ; 55c1f (15:5c1f)
 	dw Route17EndBattleText10 ; 0x5d1c TextEndBattle
 	dw Route17EndBattleText10 ; 0x5d1c TextEndBattle
 
-db $ff
+	db $ff
 
 Route17Text1: ; 55c2c (15:5c2c)
 	db $08 ; asm
@@ -85707,17 +87570,29 @@ Route17Text16: ; 55d3f (15:5d3f)
 Route19Script: ; 55d44 (15:5d44)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route19TrainerHeaders
-	ld de, Route19_Unknown55d57
+	ld de, Route19ScriptPointers
 	ld a, [W_ROUTE19CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE19CURSCRIPT], a
 	ret
 
-Route19_Unknown55d57: ; 55d57 (15:5d57)
-INCBIN "baserom.gbc",$55d57,$55d5d - $55d57
+Route19ScriptPointers: ; 55d57 (15:5d57)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route19Texts: ; 55d5d (15:5d5d)
-	dw Route19Text1, Route19Text2, Route19Text3, Route19Text4, Route19Text5, Route19Text6, Route19Text7, Route19Text8, Route19Text9, Route19Text10, Route19Text11
+Route19TextPointers: ; 55d5d (15:5d5d)
+	dw Route19Text1
+	dw Route19Text2
+	dw Route19Text3
+	dw Route19Text4
+	dw Route19Text5
+	dw Route19Text6
+	dw Route19Text7
+	dw Route19Text8
+	dw Route19Text9
+	dw Route19Text10
+	dw Route19Text11
 
 Route19TrainerHeaders: ; 55d73 (15:5d73)
 Route19TrainerHeader0: ; 55d73 (15:5d73)
@@ -85810,7 +87685,7 @@ Route19TrainerHeader9: ; 55ddf (15:5ddf)
 	dw Route19EndBattleText10 ; 0x5edc TextEndBattle
 	dw Route19EndBattleText10 ; 0x5edc TextEndBattle
 
-db $ff
+	db $ff
 
 Route19Text1: ; 55dec (15:5dec)
 	db $08 ; asm
@@ -85999,17 +87874,27 @@ Route19Text11: ; 55ee6 (15:5ee6)
 Route21Script: ; 55eeb (15:5eeb)
 	call EnableAutoTextBoxDrawing
 	ld hl, Route21TrainerHeaders
-	ld de, Route21_Unknown55efe
+	ld de, Route21ScriptPointers
 	ld a, [W_ROUTE21CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_ROUTE21CURSCRIPT], a
 	ret
 
-Route21_Unknown55efe: ; 55efe (15:5efe)
-INCBIN "baserom.gbc",$55efe,$55f04 - $55efe
+Route21ScriptPointers: ; 55efe (15:5efe)
+	dw CheckFightingMapTrainers
+	dw Func_324c
+	dw EndTrainerBattle
 
-Route21Texts: ; 55f04 (15:5f04)
-	dw Route21Text1, Route21Text2, Route21Text3, Route21Text4, Route21Text5, Route21Text6, Route21Text7, Route21Text8, Route21Text9
+Route21TextPointers: ; 55f04 (15:5f04)
+	dw Route21Text1
+	dw Route21Text2
+	dw Route21Text3
+	dw Route21Text4
+	dw Route21Text5
+	dw Route21Text6
+	dw Route21Text7
+	dw Route21Text8
+	dw Route21Text9
 
 Route21TrainerHeaders: ; 55f16 (15:5f16)
 Route21TrainerHeader0: ; 55f16 (15:5f16)
@@ -86093,7 +87978,7 @@ Route21TrainerHeader8: ; 55f76 (15:5f76)
 	dw Route21EndBattleText9 ; 0x605a TextEndBattle
 	dw Route21EndBattleText9 ; 0x605a TextEndBattle
 
-db $ff
+	db $ff
 
 Route21Text1: ; 55f83 (15:5f83)
 	db $08 ; asm
@@ -86260,7 +88145,7 @@ Route21AfterBattleText9: ; 5605f (15:605f)
 VermilionHouse2_h: ; 0x56064 to 0x56070 (12 bytes) (id=163)
 	db $08 ; tileset
 	db VERMILION_HOUSE_2_HEIGHT, VERMILION_HOUSE_2_WIDTH ; dimensions (y, x)
-	dw VermilionHouse2Blocks, VermilionHouse2Texts, VermilionHouse2Script ; blocks, texts, scripts
+	dw VermilionHouse2Blocks, VermilionHouse2TextPointers, VermilionHouse2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw VermilionHouse2Object ; objects
@@ -86268,7 +88153,7 @@ VermilionHouse2_h: ; 0x56064 to 0x56070 (12 bytes) (id=163)
 VermilionHouse2Script: ; 56070 (15:6070)
 	jp EnableAutoTextBoxDrawing
 
-VermilionHouse2Texts: ; 56073 (15:6073)
+VermilionHouse2TextPointers: ; 56073 (15:6073)
 	dw VermilionHouse2Text1
 
 VermilionHouse2Text1: ; 56075 (15:6075)
@@ -86342,7 +88227,7 @@ VermilionHouse2Object: ; 0x560cf (size=26)
 CeladonMart2_h: ; 0x560e9 to 0x560f5 (12 bytes) (id=123)
 	db $12 ; tileset
 	db CELADON_MART_2_HEIGHT, CELADON_MART_2_WIDTH ; dimensions (y, x)
-	dw CeladonMart2Blocks, CeladonMart2Texts, CeladonMart2Script ; blocks, texts, scripts
+	dw CeladonMart2Blocks, CeladonMart2TextPointers, CeladonMart2Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw CeladonMart2Object ; objects
@@ -86350,8 +88235,12 @@ CeladonMart2_h: ; 0x560e9 to 0x560f5 (12 bytes) (id=123)
 CeladonMart2Script: ; 560f5 (15:60f5)
 	jp EnableAutoTextBoxDrawing
 
-CeladonMart2Texts: ; 560f8 (15:60f8)
-	dw CeladonMart2Text1, CeladonMart2Text2, CeladonMart2Text3, CeladonMart2Text4, CeladonMart2Text5
+CeladonMart2TextPointers: ; 560f8 (15:60f8)
+	dw CeladonMart2Text1
+	dw CeladonMart2Text2
+	dw CeladonMart2Text3
+	dw CeladonMart2Text4
+	dw CeladonMart2Text5
 
 CeladonMart2Text3: ; 56102 (15:6102)
 	TX_FAR _CeladonMart2Text3
@@ -86393,7 +88282,7 @@ CeladonMart2Blocks: ; 56148 (15:6148)
 FuchsiaHouse3_h: ; 0x56170 to 0x5617c (12 bytes) (id=164)
 	db $0d ; tileset
 	db FUCHSIA_HOUSE_3_HEIGHT, FUCHSIA_HOUSE_3_WIDTH ; dimensions (y, x)
-	dw FuchsiaHouse3Blocks, FuchsiaHouse3Texts, FuchsiaHouse3Script ; blocks, texts, scripts
+	dw FuchsiaHouse3Blocks, FuchsiaHouse3TextPointers, FuchsiaHouse3Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw FuchsiaHouse3Object ; objects
@@ -86401,7 +88290,7 @@ FuchsiaHouse3_h: ; 0x56170 to 0x5617c (12 bytes) (id=164)
 FuchsiaHouse3Script: ; 5617c (15:617c)
 	jp EnableAutoTextBoxDrawing
 
-FuchsiaHouse3Texts: ; 5617f (15:617f)
+FuchsiaHouse3TextPointers: ; 5617f (15:617f)
 	dw FuchsiaHouse3Text1
 
 FuchsiaHouse3Text1: ; 56181 (15:6181)
@@ -86477,7 +88366,7 @@ FuchsiaHouse3Object: ; 0x56221 (size=34)
 DayCareM_h: ; 0x56243 to 0x5624f (12 bytes) (id=72)
 	db $08 ; tileset
 	db DAYCAREM_HEIGHT, DAYCAREM_WIDTH ; dimensions (y, x)
-	dw DayCareMBlocks, DayCareMTexts, DayCareMScript ; blocks, texts, scripts
+	dw DayCareMBlocks, DayCareMTextPointers, DayCareMScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw DayCareMObject ; objects
@@ -86485,7 +88374,7 @@ DayCareM_h: ; 0x56243 to 0x5624f (12 bytes) (id=72)
 DayCareMScript: ; 5624f (15:624f)
 	jp EnableAutoTextBoxDrawing
 
-DayCareMTexts: ; 56252 (15:6252)
+DayCareMTextPointers: ; 56252 (15:6252)
 	dw DayCareMText1
 
 DayCareMText1: ; 56254 (15:6254)
@@ -86628,7 +88517,7 @@ DayCareMObject: ; 0x56459 (size=26)
 Route12House_h: ; 0x56473 to 0x5647f (12 bytes) (id=189)
 	db $08 ; tileset
 	db ROUTE_12_HOUSE_HEIGHT, ROUTE_12_HOUSE_WIDTH ; dimensions (y, x)
-	dw Route12HouseBlocks, Route12HouseTexts, Route12HouseScript ; blocks, texts, scripts
+	dw Route12HouseBlocks, Route12HouseTextPointers, Route12HouseScript ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw Route12HouseObject ; objects
@@ -86636,7 +88525,7 @@ Route12House_h: ; 0x56473 to 0x5647f (12 bytes) (id=189)
 Route12HouseScript: ; 5647f (15:647f)
 	jp EnableAutoTextBoxDrawing
 
-Route12HouseTexts: ; 56482 (15:6482)
+Route12HouseTextPointers: ; 56482 (15:6482)
 	dw Route12HouseText1
 
 Route12HouseText1: ; 56484 (15:6484)
@@ -86710,7 +88599,7 @@ Route12HouseObject: ; 0x564de (size=26)
 SilphCo8_h: ; 0x564f8 to 0x56504 (12 bytes) (id=213)
 	db $16 ; tileset
 	db SILPH_CO_8F_HEIGHT, SILPH_CO_8F_WIDTH ; dimensions (y, x)
-	dw SilphCo8Blocks, SilphCo8Texts, SilphCo8Script ; blocks, texts, scripts
+	dw SilphCo8Blocks, SilphCo8TextPointers, SilphCo8Script ; blocks, texts, scripts
 	db $00 ; connections
 
 	dw SilphCo8Object ; objects
@@ -86719,7 +88608,7 @@ SilphCo8Script: ; 56504 (15:6504)
 	call SilphCo8_Unknown5651a
 	call EnableAutoTextBoxDrawing
 	ld hl, SilphCo8TrainerHeader0
-	ld de, Unknown_56577 ; $6577
+	ld de, SilphCo8ScriptPointers
 	ld a, [W_SILPHCO8CURSCRIPT]
 	call ExecuteCurMapScriptInTable
 	ld [W_SILPHCO8CURSCRIPT], a
